@import Foundation;

NSString* padBase64(NSString* input)
{
	NSString* output=input;
	while(output.length%4!=0)
	{
		output=[output stringByAppendingString:@"="];
	}
	return output;
}

int main(int argCount,char** argList)
{
	printf("\e[34mpolitely asking gdmf.apple.com for assets...\e[0m\n");
	
	BOOL debug=false;
	if(argCount==2)
	{
		if(strcmp(argList[1],"debug")==0)
		{
			debug=true;
		}
	}
	
	NSMutableDictionary* dictionary=NSMutableDictionary.alloc.init;
	
	// sudo /S*/L*/P*/S*/R*/seedutil current | grep 'Audience'
	dictionary[@"AssetAudience"]=@"ca60afc6-5954-46fd-8cb9-60dde6ac39fd";
	
	// 2020 MBP 13"
	dictionary[@"HWModelStr"]=@"Mac-06F11F11946D27C5";
	
	// certificate comes from a GET or malformed request
	dictionary[@"CertIssuanceDay"]=@"2019-09-06";
	
	// other required
	dictionary[@"ClientVersion"]=@2;
	dictionary[@"AssetType"]=@"com.apple.MobileAsset.MacSoftwareUpdate";
	
	if(debug)
	{
		NSLog(@"request dict: %@",dictionary);
	}
	
	NSURL* url=[NSURL URLWithString:@"https://gdmf.apple.com/v2/assets"];
	NSMutableURLRequest* request=[NSMutableURLRequest requestWithURL:url];
	request.HTTPMethod=@"POST";
	[request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
	request.HTTPBody=[NSJSONSerialization dataWithJSONObject:dictionary options:0 error:nil];
	
	NSURLSessionDataTask* task=[NSURLSession.sharedSession dataTaskWithRequest:request completionHandler:^(NSData* responseData,NSURLResponse* response,NSError* error)
	{
		// period-separated base64 strings
		NSString* responseString=[NSString.alloc initWithData:responseData encoding:NSUTF8StringEncoding];
		if(debug)
		{
			NSLog(@"response raw: %@",responseString);
		}
		NSArray<NSString*>* responseBits=[responseString componentsSeparatedByString:@"."];
		
		// main JSON data is at index 1
		NSData* jsonData=[NSData.alloc initWithBase64EncodedString:padBase64(responseBits[1]) options:NSDataBase64DecodingIgnoreUnknownCharacters
];
		if(debug)
		{
			NSString* jsonString=[NSString.alloc initWithData:jsonData encoding:NSUTF8StringEncoding];
			NSLog(@"response[1] string: %@",jsonString);
		}
		id jsonObject=[NSJSONSerialization JSONObjectWithData:jsonData options:0 error:nil];
		
		NSArray* assetList=jsonObject[@"Assets"];
		for(int assetIndex=0;assetIndex<assetList.count;assetIndex++)
		{
			id asset=assetList[assetIndex];
			NSString* build=asset[@"Build"];
			NSString* url=[asset[@"__BaseURL"] stringByAppendingString:asset[@"__RelativePath"]];
			printf("\e[35m%s\e[0m: \e[36m%s\e[0m\n",build.UTF8String,url.UTF8String);
		}
		
		exit(0);
	}];
	
	task.resume;
	
	while(true);
}